\ Final test boot script
\ 2010.10.27 delete all redundant function

d# 3000 ms
visible

: show-result-screen  ( -- )
   pass?  if
      clear-screen
      ." PASS" cr cr
      green-screen
   else
      ." FAIL" cr cr
      red-screen
   then
;

: format-date  ( s m h d m y -- adr len )
   push-decimal
   >r >r >r >r >r >r
   <#
   [char] Z hold
   r> u# u# drop
   r> u# u# drop
   r> u# u# drop
   [char] T hold
   r> u# u# drop
   r> u# u# drop
   r> u# u# u# u#
   u#>
   pop-base
;

\ $rename gives "Unimplemented package interface procedure" on ext2
: do-rename
   2>r  2dup  2r>  $copy  $delete
;

: $safe-delete   ( $name -- )
    2dup $file-exists?  if
       2dup $delete
    then
    2drop
;

: $copy!  ( $src $dst -- )
   2dup $file-exists?  if
      2dup $delete
   then
   $copy1
;


: fail-backup-file$  ( -- name$ )
   time&date format-date " int:\runin\fail-%s.log" sprintf
;
: fail-log-file$  ( -- name$ )  " int:\runin\fail.log"   ;

\ The operator can type this to reset the state to run
\ the Linux-based runin tests again.
: rerunin  ( -- )
   " int:\runin\final.fth" $safe-delete
   fail-log-file$ fail-backup-file$ do-rename
;

: after-runin  ( -- )
   fail-log-file$ $read-file  0=  if  ( adr len )
      page
      show-fail
      ." Type a key to see the failure log"
      key drop  cr cr
      list
      ." Type R to restart runin, any other key to power off "
      key dup emit cr  upc [char] R =  if
         ." Resetting state to restart runin." cr
         ." The old failure log is in " fail-backup-file$ type cr
         rerunin
      else
         power-off
      then
   else
      autorun-mfg-tests
      pass?  if
         " int:\runin\final.fth" $safe-delete
   
         " int:\runin\repass.fth" 2dup $file-exists?  if
         " int:\runin\final.fth" $copy!
         else
            2drop
            ." Do not have repass.fth ,you can't do final download!!!"
            red-screen begin halt again
         then 
      then
      show-result-screen
   then

   ." Type a key to power off ,and pull out the battery"
   key cr
   power-off
;

\ Make the "wait for SD insertion" step highly visible 
dev ext
warning @  warning off
: wait&clear  ( -- error? )  wait-card? page  ;
patch wait&clear wait-card? selftest
: selftest  ( -- )  page show-pass  selftest  ;
warning !
dend

\ Override the display self test
dev /display
warning @  warning off
: selftest  ( -- error? )
   depth d# 16 <  if  false exit  then

   .vertical-bars16     key drop cr
   .horizontal-bars16   key drop cr
    hgradient           key drop cr
    vgradient

   confirm-selftest?
;
warning ! 
device-end

." Starting final phase" cr
after-runin
